package uk.ac.strath.esru;
import java.lang.Object.*;
import java.math.BigDecimal;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.text.ParseException;
import java.util.Calendar;
import java.util.Date;
import java.util.concurrent.TimeUnit;



import org.apache.commons.lang.math.NumberUtils;


public class EnergyAlgorithm {
	public String GetEnergySaved(){
		int dummy = 0;
		String[] s 		= new String[30];
		System.out.println("Entering energy alg");
		/*
		//If incomplete information has been entered then return with empty string
		s[0] = Language.BenchMSaving.trim();
		s[1] = Language.GasMeterUnits.trim();
		s[2] = Language.PreUpStartGas.trim();
		s[3] = Language.PreUpEndGas.trim();
		s[4] = Language.PostUpStartGas.trim();
		s[5] = Language.PostUpEndGas.trim();
		s[6] = Language.PreUpStartElec.trim();
		s[7] = Language.PostUpStartElec.trim();
		s[8] = Language.PreUpEndElec.trim();
		s[9] = Language.PostUpEndElec.trim();
		s[10] = Language.PreUpStartDate.trim();
		s[11] = Language.PostUpStartDate.trim();
		s[12] = Language.PreUpEndDate.trim();
		s[13] = Language.PostUpEndDate.trim();
		s[14] = Language.Assessor.trim();
		s[15] = Language.AssmntDate.trim();
		*/
		for(int i = 0; i <= 15; i++){
			if(s[i].equals("undefined") || s[i].equals("")){
				//UserDialog dialog = new UserDialog("OK", dummy, "incomplete data", s[i] + " is not defined");
				return "";
			}
		}
		
		
		
		// Energy normalisation procedures to be applied to the 
		// Post Operations Evaluation Tool.


		// DaysNonHeatingSeason   = Number of days in the non-heating season (days)
		// StartDatePreUpgradeMonPeriod  = Start date of pre-upgrade monitoring period
		// EndDatePreUpgradeMonPeriod  = End date of pre-upgrade monitoring period
		// StartDatePostUpgradeMonPeriod  = Start date of post-upgrade monitoring period
		// EndDatePostUpgradeMonPeriod  = End date of post-upgrade monitoring period
		// DurationPreUpgradeMonPeriod  = Duration of the pre-upgrade monitoring period (days)
		// DurationPostUpgradeMonPeriod  = Duration of the post-upgrade monitoring period (days)

		// GMRSTD   = Gas meter reading recorded at start date
		// GMREND   = Gas meter reading recorded at end date

		// EnergyUsedPreUpgradePeriod   = Total energy consumption during the pre-upgrade period (kWh)
		// EnergyUsedPostUpgradePeriod   = Total energy consumption during the post-upgrade period (kWh)
		// DHWNHS   = Domestic hot water consumed during the non-heating season (kWh)
		// DHWPreUpgradePeriod   = Sum of domestic hot water use pre-upgrade (kWh)
		// DHWPostUpgradePeriod   = Sum of domestic hot water use post-upgrade (kWh)
		// DELESD   = Sum of domestic electrical appliance use pre-upgrade (kWh)
		// DELEED   = Sum of domestic electrical appliance use post-upgrade (kWh)

		// SpaceHeatOnlyEnergyPreUpgrade   = Energy consumed for space heating only pre-upgrade (kWh)
		// SpaceHeatOnlyEnergyPostUpgrade   = Energy consumed for space heating only post-upgrade (kWh)

		// MeanHourlyExtTempPreUp  = Mean hourly external temperature during the pre-upgrade period (C)
		// MeanHourlyExtTempPostUp  = Mean hourly external temperature during the post-upgrade period (C)
		// MeanIntTempPreUp   = Mean indoor temperature during the pre-upgrade period (C)
		// MeanIntTempPostUp   = Mean indoor temperature during the post-upgrade period (C)

		// MeanIntTempDegreeDayCalc   = Mean indoor temperature assumed in standard degree day calculation (C)
		// DegreeDayBaseTemp   = Base temperature taken from standard heating degree days calculation (C)

		// HeatingDegreeHrsPreUp   = Heating degree hours for the pre-upgrade period
		// HeatingDegreeHrsPostUp   = Heating degree hours for the post-upgrade period
		// HeatingDegreeDaysPreUp  = Heating degree days calculated for the pre-upgrade period 
		// HeatingDegreeDaysPostUp  = Heating degree days calculated for the post-upgrade period
		// HeatingDegreeDaysCorrPreUp  = Heating degree days accounting for outdoor climate differences and impact of insulation (pre-upgrade)
		// HeatingDegreeDaysCorrPostUp  = Heating degree days accounting for outdoor climate differences and impact of insulation (post-upgrade) 

		// NormEnergyUsePreUp   = Normalised energy consumption for pre-upgrade period
		// PercDiffPrePostEnergy   = Percentage difference between pre- and post-upgrade energy consumption (%)
		// PercExpectedBenchmarkSaving   = Expected benchmark energy saving (%)
		// PercDiffExpectedAndActualSavings   = Difference between PercDiffPrePostEnergy and PercExpectedBenchmarkSaving , this is the OUTPUT

      double GasConversionFactor,EnergyUsedPreUpgradePeriodGas,EnergyUsedPostUpgradePeriodGas,EnergyUsedPreUpgradePeriodElec,
      EnergyUsedPostUpgradePeriodElec,DELPRE,DELPST,SpaceHeatOnlyEnergyPreUpgrade,SpaceHeatOnlyEnergyPostUpgrade,
      MeanIntTempDegreeDayCalc,DegreeDayBaseTemp,MeanIntTempPreUp,MeanIntTempPostUp,NormEnergyUsePreUp,PercDiffPrePostEnergy,
      PercExpectedBenchmarkSaving,PercDiffExpectedAndActualSavings,MECDHW,ELCAPP,DHWPreUpgradePeriodGas,DHWPostUpgradePeriodGas,ELEPREElec,ELEPSTElec;
      int DurationPreUpgradeMonPeriod,DurationPostUpgradeMonPeriod,HeatingDegreeHrsPreUp,HeatingDegreeHrsPostUp,HeatingDegreeDaysPreUp,
      HeatingDegreeDaysPostUp,HeatingDegreeDaysCorrPreUp,HeatingDegreeDaysCorrPostUp,IMRDGAS,IMRDELE;  
		      
      GasConversionFactor=0;
      MeanIntTempDegreeDayCalc=19.5;
      DegreeDayBaseTemp=15.5;
		      
		// Mean energy content for DHW (MECDHW) kWh/ day
		// (Reference: Measurement of Domesti// Hot Water consumption in 
		// Dwellings, Energy Saving Trust, 2008)

		      MECDHW=4.7;

		// The annual electricity consumption related to lighting and 
		// appliance use per person can be calculated as follows 
		// (Reference: Electricity supply, electricity supplied (net), 
		// electricity available, electricity consumption and electricity 
		// sales (DUKES 5.4); Electricity: chapter 5, Digest of United 
		// Kingdom Energy Statistics (DUKES)):
		 
		// Annual electricity consumption (kWh) for cooking,water heating, 
		// lighting and appliance use (2013) = 8.846x10**10


		// Population of the UK                  = 64.1x10**6


		// Electricity consumption for lighting and appliances (ELCAPP)
		// (annual kWh/ person):


		      ELCAPP=1380; //(8.846 * 10000000000. )/(64.1 * 1000000. )kWh/person



		//***************************************************************
		// STEP 1
		// Number of days elapsed between start and end dates of 
		// each monitoring period.
		//***************************************************************
		 
		// Determines the number of days elapased between the start and 
		// end dates of both pre- and post-upgrade monitoring periods 
		// (each period must be of equal length as this information will 
		// be carried forward to STEP 5).

		// The user will enter the start and end dates of each
		// monitoring period and the difference will be calculated as
		// follows, with the result provided in days.


		      //SimpleDateFormat sdf = new SimpleDateFormat("EEE MMM dd kk:mm:ss z yyyy");
		      SimpleDateFormat sdf = new SimpleDateFormat("dd-MMM-yyyy");
		      DurationPreUpgradeMonPeriod=0; 
		      DurationPostUpgradeMonPeriod=0; 
		      try{
//		    	  Calendar c = Calendar.getInstance();
		    	  Date d1 = sdf.parse(Language.PreUpStartDate);
		    	  Date d2 = sdf.parse(Language.PreUpEndDate);
		    	  DurationPreUpgradeMonPeriod = (int)getDateDiff(d1, d2, TimeUnit.DAYS);
		    	  
		    	  d1 = sdf.parse(Language.PostUpStartDate);
		    	  d2 = sdf.parse(Language.PostUpEndDate);
		    	  DurationPostUpgradeMonPeriod = (int)getDateDiff(d1, d2, TimeUnit.DAYS);
//		    	  System.out.println("DurationPreUpgradeMonPeriod = " + DurationPreUpgradeMonPeriod);
//		    	  System.out.println("DurationPostUpgradeMonPeriod = " + DurationPostUpgradeMonPeriod);
//			      c.setTime(d);
//			      long time = c.getTimeInMillis();
			      
//			      DateFormat df = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss");
//			      System.out.println(df.format(d));
		      }catch(ParseException pe){
		    	  // 
		      }



		//***************************************************************
		// STEP 2 
		// Total energy consumption pre- and post-upgrade periods.
		//***************************************************************

		// Calculate total gas and electricity consumption over  
		// monitoring periods. Convert unit of gas meter readings to kWh 

		// The following calculations are done for the pre- and post-upgrade periods.

/*
	      if(Language.GasMeterUnits.trim().equals("kWh"))GasConversionFactor=1;
	      if(Language.GasMeterUnits.trim().equals("cubic meters"))GasConversionFactor=11.14264;
	      if(Language.GasMeterUnits.trim().equals("cubic feet"))GasConversionFactor=31.53367;
	      EnergyUsedPreUpgradePeriodGas=(Double.parseDouble(Language.PreUpEndGas) - Double.parseDouble(Language.PreUpStartGas))*GasConversionFactor;
	      EnergyUsedPostUpgradePeriodGas=(Double.parseDouble(Language.PostUpEndGas) - Double.parseDouble(Language.PostUpStartGas))*GasConversionFactor;
		 

		// For electrically heated dwellings there may be more than one 
		// meter reading. If this is the case, the user should enter the
		// sum of all values (which will already have the units kWh).

		// The equations below are used to determine electrical energy 
		// consumption for the pre- and post-upgrade periods:

		  EnergyUsedPreUpgradePeriodElec=Double.parseDouble(Language.PreUpEndElec) - Double.parseDouble(Language.PreUpStartElec);
		  EnergyUsedPostUpgradePeriodElec=Double.parseDouble(Language.PostUpEndElec) - Double.parseDouble(Language.PostUpStartElec);

*/
		//***************************************************************
		// STEP 3
		// Energy consumption related to DHW, lighting and appliances.
		//***************************************************************

		// Calculate the gas/ electricity consumption related to DHW and
		// electrical appliance use.

		/////////////////////////////IGNORE//////////////////////////////
		// If the monitoring period includes the non-heating season, it
		// may be possible to calculate a daily consumption value for DHW
		// by dividing the recorded gas consumption data from the 
		// non-heating season by the monitoring period (days) calculated
		// in STEP 1. The assumption for this calculation is that no heating
		// is used during the non-heating season.

		// DHWNHS=(GMRSTD*(CNVFG1 OR CNVFG2)-GMREND*(CNVFG1 OR CNVFG2))/DaysNonHeatingSeason
		/////////////////////////////IGNORE//////////////////////////////

		// The default values listed above for DHW and lighting and 
		// electrical appliance use can be applied in the following 
		// calculations:


		// Pre-upgrade period:

		      DHWPreUpgradePeriodGas=DurationPreUpgradeMonPeriod*MECDHW;

		// Post-upgrade period:

		      DHWPostUpgradePeriodGas=DurationPostUpgradeMonPeriod*MECDHW;


		// To calculate the electricity consumption related to lighting
		// and appliance use during the pre- and post-upgrade periods, the
		// following calculations are applied:

		// Pre-upgrade period:

		      ELEPREElec=(DurationPreUpgradeMonPeriod/365)*ELCAPP;

		// Post-upgrade period:

		      ELEPSTElec=(DurationPostUpgradeMonPeriod/365)*ELCAPP;


		//***************************************************************
		// STEP 4
		// Energy consumption related to space heating.
		//***************************************************************

		// The energy consumption (kWh) related to space heating 
		// only for both pre- and post-upgrade periods can now be 
		// determined.

		// For gas centrally heated dwellings:
/*
		      SpaceHeatOnlyEnergyPreUpgrade=EnergyUsedPreUpgradePeriodGas-DHWPreUpgradePeriodGas;
		      SpaceHeatOnlyEnergyPostUpgrade=EnergyUsedPostUpgradePeriodGas-DHWPostUpgradePeriodGas;

		// For electrically heated dwellings:

		      SpaceHeatOnlyEnergyPreUpgrade=EnergyUsedPreUpgradePeriodElec-ELEPREElec;
		      SpaceHeatOnlyEnergyPostUpgrade=EnergyUsedPostUpgradePeriodElec-ELEPSTElec;

*/
		//***************************************************************
		// STEP 5
		// Normalisation of pre-upgrade space heating energy consumption.
		//***************************************************************
		// MeanHourlyExtTempPreUp  = Mean hourly external temperature during the 
		//            pre-upgrade period (C)

		// MeanHourlyExtTempPostUp  = Mean hourly external temperature during the 
		//            post-upgrade period (C)

		// MeanIntTempPreUp   = Mean indoor temperature during the pre-upgrade period (C)
		// MeanIntTempPostUp   = Mean indoor temperature during the post-upgrade period (C)

		// MeanIntTempDegreeDayCalc   = Mean indoor temperature assumed in standard degree 
		//            day calculation (19.5C)
		// DegreeDayBaseTemp   = Base temperature taken from standard heating degree 
		//            days calculation (15.5C)

		// HeatingDegreeHrsPreUp   = Heating degree hours for the pre-upgrade period
		// HeatingDegreeHrsPostUp   = Heating degree hours for the post-upgrade period
		// HeatingDegreeDaysPreUp  = Heating degree days calculated for the pre-upgrade period 
		// HeatingDegreeDaysPostUp  = Heating degree days calculated for the post-upgrade period
		// HeatingDegreeDaysCorrPreUp  = Heating degree days accounting for outdoor climate 
		//            differences and impact of insulation (pre-upgrade)
		// HeatingDegreeDaysCorrPostUp  = Heating degree days accounting for outdoor climate 
		//            differences and impact of insulation (post-upgrade)


		// Two approaches are being proposed for the normalisation of 
		// space heating energy consumption. These are described below.

		// For the purposes of this procedure, a standard value for
		// the base temperature has been taken and defined as
		// DegreeDayBaseTemp = 15.5C. The standard mean indoor temperature of
		// 19.5// (used in the standard HDD method) has also been applied 
		// in the second approach.

		// APPROACH #1
		// This involves normalising the space heating energy 
		// consumption (calculated in STEP 4) in order to account for 
		// weather differences between the pre- and post-upgrade 
		// monitoring periods. This is done through the use of heating
		// degree days (HDD). 


		// The basi// formula for calculating HDD is as follows:

		// HDD = Base temperature - Outdoor temperature

		// Over the period specified in STEP 1, the mean outdoor 
		// temperature is calculated and subtracted from the base 
		// temperature on an hourly basis. The HDD value is then 
		// calculated by dividing the sum of the heating degree hours 
		// by 24.

		// The following equations are used to calculate the heating
		// degree hours for the pre- and post-upgrade periods.


		      //<< Taso to provide these inputs
		      // HeatingDegreeHrsPreUp=DegreeDayBaseTemp-MeanHourlyExtTempPreUp;
		      // HeatingDegreeHrsPostUp=DegreeDayBaseTemp-MeanHourlyExtTempPostUp;
		       HeatingDegreeHrsPreUp=0;
		       HeatingDegreeHrsPostUp=0;


		// The following equations are applied to calculate the heating
		// degree days, for both pre- and post-upgrade periods.

		      //<< hourly running average (over 5min data) of HeatingDegreeHrsPreUp and HeatingDegreeHrsPostUp read  
		      //<< summation is only worked out if HDD>0
		      //HeatingDegreeDaysPreUp=SUM(HeatingDegreeHrsPreUp)/24;
		      //HeatingDegreeDaysPostUp=sUM(HeatingDegreeHrsPostUp)/24;  
		       HeatingDegreeDaysPreUp=0;
		       HeatingDegreeDaysPostUp=0;  


		// The pre-upgrade space heating energy consumption (SpaceHeatOnlyEnergyPreUpgrade) 
		// can now be normalised.

/*
		      NormEnergyUsePreUp=(SpaceHeatOnlyEnergyPreUpgrade/HeatingDegreeDaysPreUp)*HeatingDegreeDaysPostUp;
*/

		// APPROACH #2
		// This involves normalising the space heating energy 
		// consumption (calculated in STEP 4) in order to account for 
		// weather differences and the impact of the improved heat 
		// transfer performance of the building envelope fabric
		// between the pre- and post-upgrade monitoring periods. 
		// This is done through the use of an adjusted heating degree 
		// days (HDD) method.

		// The average indoor and outdoor measured temperatures are
		// calculated on an hourly basis for the defined pre- and 
		// post-upgrade period. These are then substituted into the 
		// formula shown below, in order to calculate the adjusted HDD.


//		      HeatingDegreeHrsPreUp=((DegreeDayBaseTemp+(MeanIntTempPreUp-MeanIntTempDegreeDayCalc))-MeanHourlyExtTempPreUp
//		      HeatingDegreeHrsPostUp=((DegreeDayBaseTemp+(MeanIntTempPostUp-MeanIntTempDegreeDayCalc))-MeanHourlyExtTempPostUp
//
//		      HeatingDegreeDaysCorrPreUp=SUM(HeatingDegreeHrsPreUp)/24
//		      HeatingDegreeDaysCorrPostUp=SUM(HeatingDegreeHrsPostUp)/24





		//***************************************************************
		// STEP 6
		// Comparison of results with expected outcomes.
		//***************************************************************

		// The initial part of this step involves calculating the 
		// percentage difference between the normalised pre-upgrade 
		// space heating energy consumption and the post-upgrade space 
		// heating energy consumption (PercDiffPrePostEnergy).


		      //<<PercDiffPrePostEnergy=100*((NormEnergyUsePreUp-SpaceHeatOnlyEnergyPostUpgrade)/NormEnergyUsePreUp);      

		      
		// A comparison is then made between the value for PercDiffPrePostEnergy and an 
		// expected benchmark percentage energy saving (PercExpectedBenchmarkSaving) for the 
		// type of dwelling being assessed.

		      //<< John Allison to provide PercExpectedBenchmarkSaving from database, read from input file for now
		      PercExpectedBenchmarkSaving=0;
		     //<< PercDiffExpectedAndActualSavings=PercExpectedBenchmarkSaving-PercDiffPrePostEnergy; // Which is the output and should be present on the sign off certificate
		      PercDiffExpectedAndActualSavings = 0;
		      
		      return Double.toString(PercDiffExpectedAndActualSavings);
	}


	public static long getDateDiff(Date date1, Date date2, TimeUnit timeUnit) {
	    long diffInMillies = date2.getTime() - date1.getTime();
	    return timeUnit.convert(diffInMillies,TimeUnit.MILLISECONDS);
	}
}
