package uk.ac.strath.esru;

import java.awt.Desktop;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.text.StringCharacterIterator;
import java.text.CharacterIterator;

import javax.swing.JDialog;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.UnknownHostException;

import java.nio.file.*;

import static java.nio.file.StandardCopyOption.*;

import java.util.*;

public class InOut {
	//public static String release = "development";
	public static String release = "general";
	Language l = new Language();
	private String OS = null;

	// POET file specific info
	public static String installDir; // = ".";
	public static String currentFile;
	public static String currentFileDir;
	public static String currentFileNPath;
	public static String pdfReportFileNPath;
	public static String docxReportFileNPath;
	public static String weatherFile;
	public static String weatherFileDir;
	public static String weatherFileNPath;
	public static String monitoredDataFileNPath;
	public static String htmlFileNPath;

	public static String programDir;
	public static String programDir2;
	public static String homeDir;
	public static String resFileNPath;
	public static String configurationFile;
	public static String assConFile;
	public static final int maxRecentFileNo = 10;
	public static final int maxConfigFileLen = 14;
	public static String cfgRoot;
	public static String cfgRoot2;
	public static String[] siml = {"1101", "0302", "2603", "1210", "1905", "2308", "1311", "1412"};
	public static boolean excelPathSetToHWEC = false;
	
	// Version no
	public String configHeader = l.confHeader;
	public static String recentFiles[] = new String[maxRecentFileNo];
	public static boolean inputsModified;
	
	
	// Initialize various variables when program first starts
	public void Initial(){
		try {
			installDir = new java.io.File(".").getCanonicalPath(); // path of executable
//			UserDialog dialog = new UserDialog("ok", 1, installDir, "");
//			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
//			dialog.setTitle(l.warning);
//			dialog.setVisible(true);

		} catch (IOException e) {
			e.printStackTrace();
		}
		currentFile = Language.DefFileName;
		
		// Originally there were two different directories that the exe (jar file) and the user files existed in
		// This has now been modified, part of the reason is that users may not have a lot of space in their 
		// home directories and use a different network location.
		// Currently everything (exe and user files) live in the folder that the exe is installed in 
		// (as asked by the NSIS script and determined here in the try-catch block above)

		if(release.equals("development")){
			homeDir = System.getProperty("user.home");
			currentFileDir = homeDir + File.separator + l.progDirName;
		}else if(release.equals("general")){
			homeDir = installDir;
			currentFileDir = homeDir;
		}
		
		
		currentFileNPath = currentFileDir + File.separator + currentFile;
		programDir = currentFileDir + File.separator;
		configurationFile = currentFileDir + File.separator + ".configuration.txt";
		assConFile = currentFileDir + File.separator + "AssessorsContractorsList.txt";
		/*
		System.out.println("installDir = " + installDir);
		System.out.println("currentFile = "+ currentFile);
		System.out.println("currentFileDir = "+ currentFileDir);
		System.out.println("homeDir = "+ homeDir);
		System.out.println("currentFileNPath = "+ currentFileNPath);
		System.out.println("programDir = "+ programDir);
		System.out.println("configurationFile = "+ configurationFile);
		*/
		weatherFileDir = currentFileDir;

		for (int i = 0 ; i < maxRecentFileNo; i++){
			recentFiles[i] = null;
		}
		
		// Find configuration file and read recent files opened
		if(new File(configurationFile).exists()){
			readConfigFile();
		} else {
			writeConfigFile();
		}
		
		// read benchmarks database
		openPOETBuildingsDB("populate GUI");
		
		// Read assessors and contractors
		ReadAssCon();
		
		// Init all input variables
		Language.InitAll();
		
		// Init weather files
		InitWeatherFiles();
	}
	
	// Init weather files drop down in the GUI
	private void InitWeatherFiles() {
		File folder = new File(weatherFileDir);
		File[] listOfFiles = folder.listFiles();
		String fileName = "";
		
		Language.WeatherFiles[0] = " ";
		int j = 1;
		
		for (int i = 0; i < listOfFiles.length; i++) {
			fileName = listOfFiles[i].getName();
			if(fileName.contains("POET.csv") && fileName.contains("Weather_")){
				Language.WeatherFiles[j] = fileName.substring(8, fileName.indexOf("POET.csv"));
				j++;
			}
		}
		
		
	}

	// Determine operating system Windows or Linux
	public String getOsName() {
		if (OS == null) {
			OS = System.getProperty("os.name");
		}
		return OS;
	}

	public boolean isWindows() {
		return getOsName().startsWith("Windows");
	}

	public boolean isMac() {
		return (getOsName().startsWith("Mac") || getOsName().startsWith("OS X"));
	}

	public boolean isUnix() {
		return !(isWindows() || isMac());
	}
	
	// Update configuration file list (recent files)
	public void updateConfig(String action) {
		if (action.equals("update recent file list")) {
			int i = 0;	int j = 0;
			boolean readingRecentFiles = false;
			String line;
			String buffer[] = new String[maxConfigFileLen];
			File f = new File(configurationFile);
			if (f.exists()) {
				try {
					FileReader fr = new FileReader(configurationFile);
					BufferedReader br = new BufferedReader(fr);
					while ((line = br.readLine()) != null) {
						
						if (line.equals(">> Recently opened files"))readingRecentFiles = true;
						if (line.equals(">> End recently opened files list"))readingRecentFiles = false;
						if (!readingRecentFiles) {
							buffer[i] = line;
							i++;
						} else {
							if (j == 0) {
								buffer[i] = line; i++;
								buffer[i] = currentFileNPath + " " + currentFile; i++;
							} else if (j < maxRecentFileNo) {
								if(!(line.equals(currentFileNPath + " " + currentFile))){
									buffer[i] = line; i++;
								}
							}
							j++;
								//>> Update recentFiles list to show in menu
							}
					}
					br.close();
					fr.close();
				} catch (Exception e) {
					System.err.println("Error: " + e.getMessage());
				}

				//write buffer to file
				writeConfigFile(buffer);	

			// File does not exist write new
			}else{
				writeConfigFile();
			}
		}
	}

	
	
//	png
	public void openPOETFile(){
		try {
			cfgRoot = currentFile.replaceAll(".poet", "");
			FileReader fr = new FileReader(currentFileNPath);
			BufferedReader br = new BufferedReader(fr);
			String line;
			int i = 0;
			line = br.readLine();
			line = br.readLine();
			line = br.readLine();
			Language.HouseID = line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.WeatherFile = line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.ShowAddress = line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.Address = line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.PostCode = line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.ArchiType = line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.Construction = line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.Occupants = line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.TFA = line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.BenchMSaving = line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.MeterMeasures = line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.monDataFile = line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.PreUpStartDate = line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.PreUpEndDate = line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.PreUpStartMeterReading = line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.PreUpEndMeterReading = line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			
			Language.PostUpStartDate = line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.PostUpEndDate = line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.PostUpStartMeterReading = line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.PostUpEndMeterReading = line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			
			Language.Rating = line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.Assessor = line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.AssmntDate = line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.UpgradeMeasures = line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.UpgradeMeasures1 = line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.UpgradeMeasures2 = line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.stptTemp1 =  line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.stptTemp2 =  line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.stptTemp3 =  line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.stptTemp4 =  line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
//			Language.stptTemp5 =  line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
//			Language.stptTemp6 =  line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.stptRH1 =  line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			
			Language.stptRH2 =  line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
//			Language.stptRH3 =  line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
//			Language.stptRH4 =  line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.savedEnergy =  line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.envOutcome =  line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.Tenure=  line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.PropertyAge =  line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.SurveyConducted =  line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.SurveyAns1=  line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.SurveyAns2=  line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.SurveyAns3=  line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.SurveyAns4=  line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.SurveyAns5=  line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			Language.SurveyAns6=  line.substring(0, line.indexOf("=")).trim(); line = br.readLine();
			br.close();
			fr.close();

			// Mon data file path is now set
			InOut.monitoredDataFileNPath = currentFileDir  + Language.monDataFile;
			
			// Get benchmark if applicable
			Algorithm.getBenchmark();
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void savePOETFile() throws IOException{

		new File(currentFileNPath).createNewFile(); // Only creates file if it does not exist
		
		FileWriter fw = new FileWriter(currentFileNPath); 

		// write to file
		fw.write("POET file" + "\n");
		fw.write(Language.version + " version number" + "\n");
		
		fw.write(Language.HouseID + " = House ID" + "\n");
		fw.write(Language.WeatherFile + " = Weather file" + "\n");
		fw.write(Language.ShowAddress + " = Show the address" + "\n");
		fw.write(Language.Address + " = Address" + "\n");
		fw.write(Language.PostCode + " = Post code" + "\n");
		fw.write(Language.ArchiType + " = Architectural type" + "\n");
		fw.write(Language.Construction + " = Construction type" + "\n");
		fw.write(Language.Occupants + " = Occupancy" + "\n");
		fw.write(Language.TFA + " = Total floor area" + "\n");
		fw.write(Language.BenchMSaving + " = Benchmark Energy saving" + "\n");
		fw.write(Language.MeterMeasures + " = Meter measures this unit" + "\n");
		fw.write(Language.monDataFile + " = Monitored data file " + "\n");
		
		fw.write(Language.PreUpStartDate + " = Pre-upgrade meter reading start date" + "\n");
		fw.write(Language.PreUpEndDate + " = Pre-upgrade meter reading end date" + "\n");
		fw.write(Language.PreUpStartMeterReading + " = Pre-upgrade start meter reading" + "\n");
		fw.write(Language.PreUpEndMeterReading + " = Pre-upgrade end meter reading" + "\n");
		
		fw.write(Language.PostUpStartDate + " = Post-upgrade meter reading start date" + "\n");
		fw.write(Language.PostUpEndDate + " = Post-upgrade meter reading end date" + "\n");
		fw.write(Language.PostUpStartMeterReading + " = Post-upgrade start meter reading" + "\n");
		fw.write(Language.PostUpEndMeterReading + " = Post-upgrade end meter reading" + "\n");
		
		fw.write(Language.Rating + " = Rating" + "\n");
		fw.write(Language.Assessor + " = Assessor name" + "\n");
		fw.write(Language.AssmntDate + " = Date of assessment" + "\n");
		fw.write(Language.UpgradeMeasures + " = Upgrade measures 0" + "\n");
		fw.write(Language.UpgradeMeasures1 + " = Upgrade measures 1" + "\n");
		fw.write(Language.UpgradeMeasures2 + " = Upgrade measures 2" + "\n");
		
		fw.write(Language.stptTemp1 + " = " + Language.strTemp1 + "\n");
		fw.write(Language.stptTemp2 + " = " + Language.strTemp2 + "\n");
		fw.write(Language.stptTemp3 + " = " + Language.strTemp3 + "\n");
		fw.write(Language.stptTemp4 + " = " + Language.strTemp4 + "\n");
//		fw.write(Language.stptTemp5 + " = " + Language.strTemp5 + "\n");
//		fw.write(Language.stptTemp6 + " = " + Language.strTemp6 + "\n");
		fw.write(Language.stptRH1 + " = " + Language.strRH1 + "\n");
		fw.write(Language.stptRH2 + " = " + Language.strRH2 + "\n");
//		fw.write(Language.stptRH3 + " = " + Language.strRH3 + "\n");
//		fw.write(Language.stptRH4 + " = " + Language.strRH4 + "\n");
		fw.write(Language.savedEnergy + " =  % energy saved comparable to % benchmark savings \n");
		fw.write(Language.envOutcome + " =  Environmental outcome \n");
		fw.write(Language.Tenure + " =  Tenure\n");
		fw.write(Language.PropertyAge + " =  Property age\n");
		fw.write(Language.SurveyConducted + " =  survey conducted \n");
		fw.write(Language.SurveyAns1 + " =  survey answer 1 \n");
		fw.write(Language.SurveyAns2 + " =  survey answer 2 \n");
		fw.write(Language.SurveyAns3 + " =  survey answer 3 \n");
		fw.write(Language.SurveyAns4 + " =  survey answer 4 \n");
		fw.write(Language.SurveyAns5 + " =  survey answer 5 \n");
		fw.write(Language.SurveyAns6 + " =  survey answer 6 \n");
		
		
		
//		fw.write(Language. + " = " + "\n");
		fw.write("End of POET file");
		fw.close();
		
		InOut.inputsModified = false;
	}
	
	public static void savePOETDebugFile() throws IOException{

		new File(currentFileNPath + ".debug").createNewFile(); // Only creates file if it does not exist
		
		FileWriter fw = new FileWriter(currentFileNPath + ".debug"); 
		System.out.println(currentFileNPath + ".debug");

		// write to file
		fw.write("POET algorithm debugging file" + "\n");
		fw.write(Language.version + " version number" + "\n");
		
		fw.write(Language.DebugDurationPreUpgradeMonPeriod + " = DurationPreUpgradeMonPeriod" + "\n");
		fw.write(Language.DebugDurationPostUpgradeMonPeriod + " = DurationPostUpgradeMonPeriod" + "\n");
		fw.write(Language.DebugEnergyUsedPreUpgradePeriod + " = EnergyUsedPreUpgradePeriod" + "\n");
		fw.write(Language.DebugEnergyUsedPostUpgradePeriod + " = EnergyUsedPostUpgradePeriod" + "\n");
		fw.write(Language.DebugDHWPreUpgradePeriodGas + " = DHWPreUpgradePeriodGas" + "\n");
		fw.write(Language.DebugDHWPostUpgradePeriodGas + " = DHWPostUpgradePeriodGas" + "\n");
		fw.write(Language.DebugAppliancePreUpgradePeriodElec + " = AppliancePreUpgradePeriodElec" + "\n");
		fw.write(Language.DebugAppliancePostUpgradePeriodElec + " = AppliancePostUpgradePeriodElec" + "\n");
		fw.write(Language.DebugSpaceHeatOnlyEnergyPreUpgrade + " = SpaceHeatOnlyEnergyPreUpgrade" + "\n");
		fw.write(Language.DebugSpaceHeatOnlyEnergyPostUpgrade + " = SpaceHeatOnlyEnergyPostUpgrade" + "\n");
		fw.write(Language.DebugHeatingDegreeDaysPreUp + " = HeatingDegreeDaysPreUp" + "\n");
		fw.write(Language.DebugHeatingDegreeDaysPostUp + " = HeatingDegreeDaysPostUp" + "\n");
		fw.write(Language.DebugNormEnergyUsePreUp + " = NormEnergyUsePreUp" + "\n");
		fw.write(Language.DebugPercDiffPrePostEnergy + " = PercDiffPrePostEnergy" + "\n");
		fw.write(Language.DebugT1Mean + " = T1Mean" + "\n");
		fw.write(Language.DebugT1MoreThanHigher + " = T1MoreThanHigher" + "\n");
		fw.write(Language.DebugT1MoreThanHigh + " = T1MoreThanHigh" + "\n");
		fw.write(Language.DebugT1LessThanLow + " = T1LessThanLow" + "\n");
		fw.write(Language.DebugT1LessThanLower + " = T1LessThanLower" + "\n");
		fw.write(Language.DebugT2Mean + " = T2Mean" + "\n");
		fw.write(Language.DebugT2MoreThanHigher + " = T2MoreThanHigher" + "\n");
		fw.write(Language.DebugT2MoreThanHigh + " = T2MoreThanHigh" + "\n");
		fw.write(Language.DebugT2LessThanLow + " = T2LessThanLow" + "\n");
		fw.write(Language.DebugT2LessThanLower + " = T2LessThanLower" + "\n");
		fw.write(Language.DebugRHMean + " = RHMean" + "\n");
		fw.write(Language.DebugRHMoreThanHigher + " = RHMoreThanHigher" + "\n");
		fw.write(Language.DebugRHMoreThanHigh + " = RHMoreThanHigh" + "\n");
		fw.write(Language.DebugRHLessThanLow + " = RHLessThanLow" + "\n");
		fw.write(Language.DebugRHLessThanLower + " = RHLessThanLower" + "\n");
		
		for(int i = 0; i <= Language.NN; i++){
			if(!Language.DebugExtended[i].equals("undefined"))fw.write(Language.DebugExtended[i]);
		}
		
//		fw.write(Language. + " = " + "\n");
		fw.write("End of POET debugging file");
		fw.close();
		
		InOut.inputsModified = false;
	}
	
//	*/
	public static void openPOETBuildingsDB(String mode){
		String[] ptyage = new String[18000]; // property age 
		String[] archit = new String[18000]; // archetype
		String[] constr = new String[18000]; // construction
		String[] ocpncy = new String[18000]; // occupancy
		String[] mnuptp = new String[18000]; // main upgrade type

		try {
			File f = new File(currentFileDir + File.separator + "benchmarkDb.csv");
			if(!f.exists()){
				InOut.UserMsg("Error: Building benchmarks database (" + currentFileDir + File.separator + "benchmarkDb.csv" + ") not found ");
				return;
			}
			FileReader fr = new FileReader(currentFileDir + File.separator + "benchmarkDb.csv");
			BufferedReader br = new BufferedReader(fr);
			String line;
			int i = 0;
			if(mode.equals("get BM"))Language.BenchMSaving = "undefined";
			while ((line = br.readLine()) != null) {
				String wData[] = line.split(",");
				
				
				if(mode.equals("populate GUI")){
					ptyage[i] = wData[0];
					archit[i] = wData[1];
					constr[i] = wData[2];
					ocpncy[i] = wData[3];
					mnuptp[i] = wData[4];
					i++;
				}else if(mode.equals("get BM")){
					if(	Language.ArchiType.trim().equals(wData[1].trim()) &&
						Language.Construction.trim().equals(wData[2].trim()) &&
						Language.Occupants.trim().equals(wData[3].trim()) &&
						Language.PropertyAge.trim().equals(wData[0].trim()) &&
						Language.UpgradeMeasures.trim().equals(wData[4].trim())
					) Language.BenchMSaving = wData[5];
					if(Language.BenchMSaving.trim().equals("-1"))Language.BenchMSaving = "undefined";		
					/*
					if(Language.ArchiType.equals(wData[1])){
						if(Language.Construction.equals(wData[2])){
							if(Language.Occupants.equals(wData[3])){
								if(Language.PropertyAge.equals(wData[0])){
									if(Language.UpgradeMeasures.equals(wData[4])){
										Language.BenchMSaving = wData[3];
									}
								}
							}
						}
					}
					*/
				}
			}

			br.close();
			fr.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		if(mode.equals("populate GUI")){
			// Read unique items to archetype
			Language.archetype = new HashSet<String>(Arrays.asList(archit)).toArray(new String[0]);
			Language.archetype[0] = " "; 	// first element is always null after above process, 
			// convert to sort-able string 
			Arrays.sort(Language.archetype);
			
			Language.occupancy = new HashSet<String>(Arrays.asList(ocpncy)).toArray(new String[0]);
			Language.occupancy[0] = " ";
			Arrays.sort(Language.occupancy);
			
			Language.construction= new HashSet<String>(Arrays.asList(constr)).toArray(new String[0]);
			Language.construction[0] = " ";
			Arrays.sort(Language.construction);

			Language.propertyage= new HashSet<String>(Arrays.asList(ptyage)).toArray(new String[0]);
			Language.propertyage[0] = " ";
			Arrays.sort(Language.propertyage);
			
			Language.mainupgradetype= new HashSet<String>(Arrays.asList(mnuptp)).toArray(new String[0]);
			Language.mainupgradetype[0] = " ";
			Arrays.sort(Language.mainupgradetype);
		}
	}
	
	
	public void closeFile(){
		updateConfig("update recent file list");
		
		//>> close file unless title is Untitled in which case ask user to save
		System.out.println("File " + currentFile +" close ho");
			
	}
	
	public void readConfigFile(){
		boolean readingRecentFiles = false;
		try {
			FileReader fr = new FileReader(configurationFile);
			BufferedReader br = new BufferedReader(fr);
			String line;
			int i = -2;
			while ((line = br.readLine()) != null) {
				
				// Read recent files
				if (line.equals(">> Recently opened files"))readingRecentFiles = true;
				if (line.equals(">> End recently opened files list"))readingRecentFiles = false;
				if (readingRecentFiles) i++;
				if (readingRecentFiles && i >= 0){
					int j = line.indexOf(" ");
					recentFiles[i] = line.substring(j);
				}
			}
			br.close();
			fr.close();
		} catch (FileNotFoundException e1) {
			// e1.printStackTrace();
		} catch (IOException e1) {
			// e1.printStackTrace();
		}

	}
	
	// Write configuration file 
	public void writeConfigFile(){
		// If program directory does not exist create it
		if(!(new File(currentFileDir).exists())){
			new File(currentFileDir).mkdir();  // Make program directory
			
			String installDirTemp = installDir;
			installDir = installDirTemp;

		}
		FileWriter fw;
		try {
			fw = new FileWriter(configurationFile);
			BufferedWriter bw = new BufferedWriter(fw);
			bw.write(configHeader + "\n");
			bw.write(">> Recently opened files" + "\n");
			for(int i = 0; i < maxRecentFileNo; i++){
				if(recentFiles[i] != null) bw.write(recentFiles[i] + "\n");				
			}
			bw.write(">> End recently opened files list" + "\n");
			bw.close();
			fw.close();
		} catch (IOException e) {
			UserDialog dialog = new UserDialog(l.OK, 0, l.nothing,l.modelPathNotWritable);
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setTitle(l.warning);
			dialog.setVisible(true);
			e.printStackTrace();
		}
	}
	
	// Update configuration file
	public void writeConfigFile(String stringToWrite[]){
		//write buffer to file
		try {
			File f = new File(configurationFile);
			FileWriter fw = new FileWriter(f.getAbsoluteFile());
			BufferedWriter bw = new BufferedWriter(fw);
			int i = 0;
			while(stringToWrite[i] != null && i < maxConfigFileLen){
				bw.write(stringToWrite[i] + "\n"); i++;
			}
			bw.close();
			fw.close();
		} catch (IOException e) {
			UserDialog dialog = new UserDialog(l.OK, 0, l.nothing,l.modelPathNotWritable);
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setTitle(l.warning);
			dialog.setVisible(true);
			e.printStackTrace();
		}
	}

	// update weather data files based on file provided by user
	public void updateWeatherFile(){
		String lastReadTemp = "20";
		String lastReadRH = "60";
		try {
			FileReader fr = new FileReader(InOut.weatherFileNPath);
			BufferedReader br = new BufferedReader(fr);
			
			FileWriter fw = new FileWriter(InOut.weatherFileNPath + "cleaned");
			BufferedWriter bw = new BufferedWriter(fw);

			String line;
			int i = 0;
			int noDataInstances = 0;
			while ((line = br.readLine()) != null) {
				String wData[] = line.split(",");
				readIntoDB:{
					if(wData[0].trim().equals("Date") || wData[0].trim().equals(""))break readIntoDB;	// do not read first two lines
					i++; // increment counter
					
					if(wData[2].trim().contains("No Data") || wData[3].trim().contains("No Data")){
						noDataInstances++;
						if(wData[2].trim().contains("No Data"))	wData[2] = lastReadTemp;
						if(wData[3].trim().contains("No Data"))	wData[3] = lastReadRH;
					}
					bw.write( wData[0] + "," + wData[1] + "," + wData[2] + "," + wData[3] + "\n");
					lastReadTemp = wData[2];
					lastReadRH = wData[3];
				}
			}
			
			br.close();
			fr.close();
			bw.close();
			fw.close();

			// Do not load data if more than 10% is bad
			if(noDataInstances > (i / 10)){		
				UserDialog dialog = new UserDialog(l.OK, 0, "", l.weatherDataBad);
				dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
				dialog.setTitle(l.warning);
				dialog.setVisible(true);
				File file = new File(InOut.weatherFileNPath + "cleaned");
				file.delete();
			}
			
			// Load data into existing weather files or create new ones if not found
			File f = new File(weatherFileDir);
			if (!(f.exists() && f.isDirectory())) {
				// Create a directory; all non-existent ancestor directories are
				// automatically created
				boolean success = f.mkdirs();
				if (!success) {
					UserDialog dialog = new UserDialog(l.OK, 0, "", "Could not create ward weather data directory, make sure path " + weatherFileDir + " is write enabled and disk space is available");
					dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
					dialog.setTitle(l.warning);
					dialog.setVisible(true);
					return;
				}
			}
			

			Path source = Paths.get(weatherFileNPath + "cleaned", "");
			System.out.println(weatherFileDir);
			System.out.println(weatherFileNPath);
			System.out.println(weatherFile);
			Path target = Paths.get(weatherFileDir + File.separator + "Weather_" + weatherFile.replace(".csv", "POET.csv").trim(),  "");
//			Path target = Paths.get(weatherFileNPath.replace(".csv", "POET.csv").trim(),  "");
			Files.move(source, target, REPLACE_EXISTING);
			UserDialog dialog = new UserDialog(l.OK, 0, "", "Weather file will be available in drop down after POET restart");
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setTitle(l.warning);
			dialog.setVisible(true);
		} catch (FileNotFoundException e1) {
			// e1.printStackTrace();
		} catch (IOException e1) {
			// e1.printStackTrace();
		}
		
		InitWeatherFiles();
	}

	// Read monitored data file and write the output into Algorithm.* array 
	// sized by maximum number of lines allowed in monitored file
	public static void readMonDataFile(String action){
		boolean dataReadOK = false;
		String lastReadTemp1 = "20";
		String lastReadTemp2 = "20";
		String lastReadRH = "60";
		try {
			FileReader fr = new FileReader(InOut.monitoredDataFileNPath);
			BufferedReader br = new BufferedReader(fr);
			
			String line;
			int i = 0;
			int noDataInstances = 0;
			br.readLine(); // top two lines is header
			br.readLine();
			while ((line = br.readLine()) != null) {
				String wData[] = line.split(",");
				
				if(wData[2].trim().contains("No Data") || wData[3].trim().contains("No Data")
						|| wData[4].trim().contains("No Data")){
					noDataInstances++;
					if(wData[2].trim().contains("No Data"))	wData[2] = lastReadTemp1;
					if(wData[3].trim().contains("No Data"))	wData[3] = lastReadTemp2;
					if(wData[4].trim().contains("No Data"))	wData[4] = lastReadRH;
				}
				String Date[] = wData[0].split("/");
				Algorithm.year[i] = Date[2];
				Algorithm.month[i] = Date[1];
				Algorithm.day[i] = Date[0];
				
				String Time[] = wData[1].split(":");
				Algorithm.hour[i] = Time[0];
				Algorithm.minute[i] = Time[1];
				Algorithm.second[i] = Time[2];

				DateFormat format = new SimpleDateFormat("dd/MM/yyyy hh:mm:ss");
				DateFormat monInFormat = new SimpleDateFormat("dd/MM/yyyy");
				DateFormat monFormat = new SimpleDateFormat("dd-MMM-yyyy");
				String dateStr = wData[0] + " " + wData[1];

				try {
					Date PostUpStartDate = monFormat.parse(Language.PostUpStartDate);
					Date DayAfterPostUpEndDate = monFormat.parse(Language.PostUpEndDate);
					Date currentDate = format.parse(dateStr);
					Algorithm.date[i] = currentDate;
					
					Calendar cal = Calendar.getInstance();
					cal.setTime(DayAfterPostUpEndDate);
				    cal.add(Calendar.DAY_OF_MONTH, 1);
				    DayAfterPostUpEndDate = cal.getTime();
					
					if(currentDate.before(PostUpStartDate)){
						// do not include dates before post upgrade period starts
						if(i <= Algorithm.lineNoMonFilePostUpStart){
							Algorithm.lineNoMonFilePostUpStart = i + 1;
						}
					}else if(currentDate.equals(DayAfterPostUpEndDate)){ // if no monitored data collected after this date
						Algorithm.lineNoMonFilePostUpEnd = i;
					}else if(currentDate.before(DayAfterPostUpEndDate)){
						Algorithm.lineNoMonFilePostUpEnd = i;
					}
				} catch (ParseException e) {
					UserMsg("Enter date for post upgrade period");
					e.printStackTrace();
					return;
				}

				Algorithm.temp1[i] = Double.parseDouble(wData[2]); 
				Algorithm.temp2[i] = Double.parseDouble(wData[3]); 
				Algorithm.RH[i] = Double.parseDouble(wData[4]);
				i++;
				lastReadTemp1 = wData[2];
				lastReadTemp2 = wData[3];
				lastReadRH = wData[4];
			}
			Algorithm.lineNoMonFilePostUpStart--;
			Language.monFileSize = i;
			br.close();
			fr.close();
			dataReadOK = true;
			
			// Do not load data if more than 10% is bad
			if(noDataInstances > (i / 10)){		
				UserDialog dialog = new UserDialog("OK", 0, "", Language.monitDataBad);
				dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
				dialog.setTitle("warning");
				dialog.setVisible(true);
				File file = new File(InOut.weatherFileNPath + "cleaned");
				file.delete();
				dataReadOK = false;
			}
		} catch (FileNotFoundException e1) {
			// e1.printStackTrace();
		} catch (ArrayIndexOutOfBoundsException e1){
			InOut.UserMsg("Error: Maximum input file records (" + Integer.toString((Integer) Algorithm.monsize) + ") exceeded");
		} catch (IOException e1) {
			// e1.printStackTrace();
		}

		// generate graph if data read OK
		if(dataReadOK && action.trim().equals("graph"))
			try {
				GenGraph();
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
	}
		
	public static String forRegex(String aRegexFragment){
		/**
		   Replace characters having special meaning in regular expressions
		   with their escaped equivalents, preceded by a '\' character.
		  
		   <P>The escaped characters include :
		  <ul>
		  <li>.
		  <li>\
		  <li>?, * , and +
		  <li>&
		  <li>:
		  <li>{ and }
		  <li>[ and ]
		  <li>( and )
		  <li>^ and $
		  </ul>
		  */
		final StringBuilder result = new StringBuilder();

	    final StringCharacterIterator iterator = 
	      new StringCharacterIterator(aRegexFragment)
	    ;
	    char character =  iterator.current();
	    while (character != CharacterIterator.DONE ){
	      /*
	       All literals need to have backslashes doubled.
	      */
	      if (character == '.') {
	        result.append("\\.");
	      }
	      else if (character == '\\') {
	        result.append("\\\\");
	      }
	      else if (character == '?') {
	        result.append("\\?");
	      }
	      else if (character == '*') {
	        result.append("\\*");
	      }
	      else if (character == '+') {
	        result.append("\\+");
	      }
	      else if (character == '&') {
	        result.append("\\&");
	      }
	      else if (character == ':') {
	        result.append("\\:");
	      }
	      else if (character == '{') {
	        result.append("\\{");
	      }
	      else if (character == '}') {
	        result.append("\\}");
	      }
	      else if (character == '[') {
	        result.append("\\[");
	      }
	      else if (character == ']') {
	        result.append("\\]");
	      }
	      else if (character == '(') {
	        result.append("\\(");
	      }
	      else if (character == ')') {
	        result.append("\\)");
	      }
	      else if (character == '^') {
	        result.append("\\^");
	      }
	      else if (character == '$') {
	        result.append("\\$");
	      }
	      else {
	        //the char is not a special one
	        //add it to the result as is
	        result.append(character);
	      }
	      character = iterator.next();
	    }
	    return result.toString();
	  }
	static void UserMsg(String msg){
		UserDialog dialog = new UserDialog("ok", 1, "", msg);
		dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		dialog.setTitle(Language.warning);
		dialog.setVisible(true);
	}
	
	static void GenGraph() throws InterruptedException{
		if(currentFile.equals("Untitled")){
			InOut.UserMsg("Error: Save file first");
			return;
		}
		try {
			System.out.println(htmlFileNPath);
			new File(htmlFileNPath).createNewFile();
			FileWriter fw = new FileWriter(htmlFileNPath); 
			
			fw.write("<!DOCTYPE HTML>\n");
			fw.write("<html>\n");
			fw.write("\n");
			fw.write("<head>\n");
			fw.write("    <meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"></meta>\n");
			fw.write("    <title>POET" + Language.version + " Data</title>\n");
			fw.write("\n");
			fw.write("    <script type=\"text/javascript\" src=\"http://ajax.googleapis.com/ajax/libs/jquery/1.8.2/jquery.min.js\"></script>\n");
			fw.write("    <style type=\"text/css\">\n");
			fw.write("        $ {\n");
			fw.write("            demo.css\n");
			fw.write("        }\n");
			fw.write("    </style>\n");
			fw.write("    <script type=\"text/javascript\">\n");
			fw.write("        <!-- Begin High charts code-->\n");
			fw.write("        $(function() {\n");
			fw.write("            $('#container').highcharts({\n");
			fw.write("                chart: {\n");
			fw.write("                    type: 'spline',\n");
			fw.write("                    zoomType: 'x',\n");
			fw.write("                    //spacingTop: 40\n");
			fw.write("                },\n");
			fw.write("                credits: {\n");
			fw.write("                enabled: true\n");
			fw.write("                },\n");
			fw.write("                exporting: false,\n");
			fw.write("                title: {\n");
			fw.write("                    //text: 'Eltek data', // suppress this in the static chart in POET\n");
			fw.write("                    text: '',\n");
			fw.write("                    y: -20,\n");
			fw.write("                },\n");
			fw.write("                subtitle: { // also suppress the subtitle as they cannot click to drag.\n");
			fw.write("                    y: -5,\n");
			fw.write("                    //text: document.ontouchstart === undefined ?\n");
			fw.write("                    //    'Click and drag in the plot area to zoom in' : 'Pinch the chart to zoom in'\n");
			fw.write("                },\n");
			fw.write("                xAxis: [{\n");
			fw.write("                    type: 'datetime',\n");
			fw.write("                    title: {\n");
			fw.write("                        text: 'Date/Time'\n");
			fw.write("                    },\n");
			
			
			SimpleDateFormat sdf = new SimpleDateFormat("dd-MMM-yyyy");
			SimpleDateFormat output = new SimpleDateFormat("yyyy,MM,dd");
			String PreUpS = "";
			String PreUpE = "";
			String PostUpS = "";
			String PostUpE = "";
			try {
				Date PreUpStart 	= sdf.parse(Language.PreUpStartDate);
				Date PreUpEnd		= sdf.parse(Language.PreUpEndDate);
				Date PostUpStart 	= sdf.parse(Language.PostUpStartDate);
				Date PostUpEnd		= sdf.parse(Language.PostUpEndDate);
				
				// Subtract one month from the dates because of how highcharts processes them (month 0 = January)
				PreUpS  = DelOneMonth(output.format(PreUpStart),1);
				PreUpE  = DelOneMonth(output.format(PreUpEnd),1);
				PostUpS = DelOneMonth(output.format(PostUpStart),1);
				PostUpE = DelOneMonth(output.format(PostUpEnd),1);
				
			} catch (ParseException e) {
				e.printStackTrace();
			}
			fw.write("					  plotBands:[{\n");
			fw.write("                    color: 'rgba(167,169,172,0.20)',\n");
			fw.write("                    from: Date.UTC(" + PreUpS + "),\n"); // <<
			fw.write("                    to: Date.UTC(" + PreUpE + "),\n");   // <<
			fw.write("                    label: {\n");
			fw.write("                    text: 'Pre-upgrade period',\n");
			fw.write("                    align: 'center',\n"); 			
			fw.write("                    },\n");
			fw.write("                    }, {\n");
			fw.write("                    color: 'rgba(167,169,172,0.20)',\n");
			fw.write("                    from: Date.UTC(" + PostUpS + "),\n"); // <<
			fw.write("                    to: Date.UTC(" + PostUpE + "),\n");   // <<
			fw.write("                    label: {\n");
			fw.write("                    text: 'Post-upgrade period',\n");
			fw.write("                    align: 'center',\n");
			fw.write("                    },\n");
			fw.write("                    }\n");
			fw.write("                    ],\n");

			fw.write("                }],\n");
			fw.write("                yAxis: [{ // Primary yAxis\n");
			fw.write("                    title: {\n");
			fw.write("                        text: \'Temperature (" +"\\xB0" +"C)\' //degrees in superscript (C)\n");
//			fw.write("                        text: \'Temperature (" +"\u00b0" +"C)\' //degrees in superscript (C)\n");
			fw.write("                    },\n");
			fw.write("                    min: 0,\n");
			fw.write("		    max: 40,\n");
			fw.write("                    plotLines: [{\n");
			fw.write("                        value: 0,\n");
			fw.write("                        width: 1,\n");
			fw.write("                        color: '#808080'\n");
			fw.write("                    }]\n");
			fw.write("                }, { // Secondary yAxis\n");
			fw.write("				title: {\n");
			fw.write("					text: 'Relative Humidity (%)',\n");
			fw.write("				},\n");
			fw.write("				max: 100,\n");
			fw.write("				min: 0,\n");
			fw.write("				opposite: true\n");
			fw.write("				},],\n");
			fw.write("                tooltip: {\n");
			fw.write("                    shared: true\n");
			fw.write("                },\n");
			fw.write("                legend: {\n");
			fw.write("                    verticalAlign: 'top',\n");
			fw.write("                    //y: 30,\n");
			fw.write("                },\n");
			fw.write("                series: [{\n");
			fw.write("name: 'Temperature 1',\n");
			fw.write("data: [\n");
			
			int lim = Language.monFileSize;
			for(int i = 0; i < lim; i++){
				fw.write	("[Date.UTC(" + Algorithm.year[i] + ", " + DelOneMonth(Algorithm.month[i],2) + ", " + 
							 Algorithm.day[i] + ", " + Algorithm.hour[i] + ", " + Algorithm.minute[i] + 
							 ", " + Algorithm.second[i] + ")," + Algorithm.temp1[i] + "],\n");
			}
//			[Date.UTC(2014, 11, 08, 13, 36, 25),18.0],
//			[Date.UTC(202014 , 10 ,06,10,36,00),18.3],\n");
//			fw.write("[Date.UTC(202014 , 10 ,06,10,36,00),18.3],\n");
//
//			fw.write("[Date.UTC(202014 , 10 ,17,11,46,00),14.1],\n");
			fw.write("],\n");
			fw.write("animation: false,\n");
			fw.write("color: 'rgb(0,120,174)',\n");
			fw.write("tooltip: {\n");
			fw.write("valueSuffix: '\\xB0C'\n");
			fw.write("}\n");
			fw.write("                }, {\n");
			fw.write("name: 'Temperature 2',\n");
			fw.write("data: [\n");

			for(int i = 0; i < lim; i++){
				fw.write	("[Date.UTC(" + Algorithm.year[i] + ", " + DelOneMonth(Algorithm.month[i],2) + ", " + 
							 Algorithm.day[i] + ", " + Algorithm.hour[i] + ", " + Algorithm.minute[i] + 
							 ", " + Algorithm.second[i] + ")," + Algorithm.temp2[i] + "],\n");
			}

			fw.write("],\n");
			fw.write("animation: false,\n");
			fw.write("color: 'rgb(244,123,32)',\n");
			fw.write("tooltip: {\n");
			fw.write("	valueSuffix: '\\xB0C'\n");
			fw.write("}\n");
			fw.write("                }, {\n");
			fw.write("name: 'Relative humidity',\n");
			fw.write("data: [\n");

			for(int i = 0; i < lim; i++){
				fw.write	("[Date.UTC(" + Algorithm.year[i] + ", " + DelOneMonth(Algorithm.month[i],2) + ", " + 
							 Algorithm.day[i] + ", " + Algorithm.hour[i] + ", " + Algorithm.minute[i] + 
							 ", " + Algorithm.second[i] + ")," + Algorithm.RH[i] + "],\n");
			}

			fw.write("],\n");
			fw.write("animation: false,\n");
			fw.write("yAxis: 1,\n");
			fw.write("color: 'rgb(93,151,50)',\n");
			fw.write("//dashStyle: 'ShortDot',\n");
			fw.write("tooltip: {\n");
			fw.write("valueSuffix: '%'\n");
			fw.write("}\n");
			fw.write("                }\n");
			fw.write("                ]\n");
			fw.write("            });\n");
			fw.write("        });\n");
			fw.write("        <!-- End High charts code-->\n");
			fw.write("    </script>\n");
			fw.write("</head>\n");
			fw.write("\n");
			fw.write("<body>\n");
			fw.write("    <!-- path to high charts: -->\n");
			fw.write("    <script src=\"js/highcharts.js\"></script>\n");
			fw.write("    <script src=\"js/modules/exporting.js\"></script>\n");
			fw.write("\n");
			fw.write("    <div id=\"container\" style=\"min-width: 310px; height: 400px; margin: 0 auto\"></div>\n");
			fw.write("\n");
			fw.write("</body>\n");
			fw.write("\n");
			fw.write("</html>\n");
			
			fw.close();

			if(Algorithm.debug){
				File myFile = new File(htmlFileNPath);
				Desktop.getDesktop().open(myFile);
			}
			
			// Write script to take screen shot
			fw = new FileWriter(InOut.currentFileDir + "\\captureImageJavaScript.js");
			fw.write("var system = require('system');\n");
			fw.write("var page = require('webpage').create();\n");

			fw.write("page.viewportSize = { width: 570, height: 370 };\n");
			fw.write("page.open('file:///" + htmlFileNPath.replace("\\", "/") + "', function(status) {\n");
			fw.write("console.log(\"Status: \" + status);\n");
			fw.write("if(status === \"success\") {\n");
			fw.write("page.render('" + htmlFileNPath.replace("\\", "/").replace(".html", ".png") + "');\n");
//			fw.write("page.render('" + InOut.currentFile + ".png');\n");
			fw.write("}	\n");
			fw.write("phantom.exit();\n");
			fw.write("});\n");
			fw.close();
			
			
			Runtime rt = Runtime.getRuntime();
			
			// Get file and path of png file
			File f = new File(InOut.currentFileDir + InOut.currentFile + ".png ");
//			System.out.print("This is the file to be waited on = ");
//			System.out.println(InOut.currentFileDir + InOut.currentFile + ".png ");

			if(!isInternetAvailable()){
				UserMsg("Connect to Internet to view graph. Your calculation will work correctly though.");
			}else {				
				// Delete existing png file
				f.delete();
				// create new png file
//			System.out.println("bf calling phantom.js");
				rt.exec("cmd.exe /C CALL " + InOut.currentFileDir + "bin\\phantomjs.exe " + InOut.currentFileDir + "captureImageJavaScript.js");
//			System.out.println("af calling phantom.js");
//			System.out.println(InOut.currentFileDir + "bin\\phantomjs.exe " + InOut.currentFileDir + "captureImageJavaScript.js");
				
				// wait until png file appears
				
				boolean breakout = false;
				for(int jj = 1; jj <= 60; jj++){
					if(f.exists()){
						rt.exec("cmd.exe /C CALL move " + InOut.currentFile + ".png " +  InOut.currentFileDir);
						breakout = true;
					}else{
						java.lang.Thread.sleep(1000);
					}
					if(breakout)break;
				}
				if(!breakout)UserMsg("There was a problem with the upload!");
			}
						
		} catch (IOException e) {
			
			e.printStackTrace();
		} // Only creates file if it does not exist
		

	}

	static void ReadAssCon(){
		boolean readingAssessors = false;
		int rA = 0;
		try {
				FileReader fr = new FileReader(InOut.assConFile);
				BufferedReader br = new BufferedReader(fr);
				String line;
				while ((line = br.readLine()) != null) {
					if(!line.startsWith("#")){ // ignore comments
						if(line.startsWith("*EndAssessors"))readingAssessors = false;

						if(readingAssessors){
							Language.Assessors[rA] = line;
							rA++;
						}

						if(line.startsWith("*StartAssessors"))readingAssessors = true;
					}
				}
		} catch (FileNotFoundException e1) {
			// e1.printStackTrace();
		} catch (IOException e1) {
			// e1.printStackTrace();
		}
	}

	// Method to delete one from the month number to make it compatible with highcharts format
	private static String DelOneMonth(String original, int mode){
		if(mode == 1){ //convert date in format yyyy,mm,dd
			String subString = original.substring(5,7);
			int tempInt = Integer.parseInt(subString) - 1;
			return original.substring(0, 5) + tempInt + original.substring(7);
		}else if(mode == 2){ // convert month number as integer
			int tempInt = Integer.parseInt(original) - 1;
			return Integer.toString(tempInt);
		}else{
			return "DelOneMonth called with bad mode";
		}
	}
	
    public static boolean isInternetAvailable() throws IOException
    {
        return isHostAvailable("google.com") || isHostAvailable("amazon.com")
                || isHostAvailable("facebook.com")|| isHostAvailable("apple.com");
    }

    private static boolean isHostAvailable(String hostName) throws IOException
    {
        try(Socket socket = new Socket())
        {
            int port = 80;
            InetSocketAddress socketAddress = new InetSocketAddress(hostName, port);
            socket.connect(socketAddress, 3000);

            return true;
        }
        catch(UnknownHostException unknownHost)
        {
            return false;
        }
    }

}

















