package uk.ac.strath.esru;
import java.io.File;
import org.apache.commons.io.FileUtils;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Date;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.OutputStream;


// iText
import com.itextpdf.text.Document;
import com.itextpdf.text.DocumentException;
import com.itextpdf.text.Image;
import com.itextpdf.text.Element;
import com.itextpdf.text.Font;
import com.itextpdf.text.Font.FontFamily;
import com.itextpdf.text.FontFactory;
import com.itextpdf.text.Paragraph;
import com.itextpdf.text.pdf.PdfWriter;
import com.itextpdf.text.PageSize;
import com.itextpdf.text.Chunk;
import com.itextpdf.text.BaseColor;
import com.itextpdf.text.Phrase;
import com.itextpdf.text.pdf.draw.LineSeparator;
import com.itextpdf.text.pdf.PdfPTable;
import com.itextpdf.text.pdf.PdfPCell;

public class MakeCertificate {

	/** Path to the resulting PDF file. */
//>>	public static final String DEST	= "undefined";
		public static String DEST	= "undefined";

	/** Path to images. */
//>>	public static final String Pic1 = "resources/img/preCal.png";
//>>	public static final String Pic2 = "resources/img/postCal.png";
	public static String Pic1 = "undefined";
	public static String Pic2 = "undefined";

	public void createPdf(String dest)
			throws DocumentException, IOException {
		InOut.pdfReportFileNPath = InOut.currentFileNPath.replace(".poet", ".pdf"); 
		DEST = InOut.pdfReportFileNPath; 
		Pic1 = InOut.currentFileDir +  "myHousePic.png"; //currentFileNPath.replace(".poet", "Pic.png");
		Pic2 = Pic1;
//		Pic1 = InOut.currentFileNPath.replace(".poet", "Pic.png");
//		Pic2 = InOut.currentFileNPath.replace(".poet", "Pic.png");

		// step 1: Create a Document
		Document document = new Document(PageSize.A4);
		document.setMargins(36f, 36f, 36f, 36f); // Set margins to 0.5in.(36pt)  all round

		// step 2: Get a PdfWriter instance
		PdfWriter.getInstance(document, new FileOutputStream(DEST));
		
		// step 3: Open the Document
		document.open();

		// step 4: Add content
		/**********************************************************************
		 * Create document header
		 *********************************************************************/
		// Title:
		Font titleFont = FontFactory.getFont(
				FontFactory.HELVETICA, 20, Font.NORMAL,
				new BaseColor(255,255,255));
		String titleText = "Insulation Compliance Output Document";
		Chunk title = new Chunk(titleText, titleFont);

		// Calculate title box margins:
		double pageWidth = 595; 			// width of A4 paper
		double lineWidth = pageWidth - 72;  // width of text block
		double titlePadding = (lineWidth - title.getWidthPoint())/2;
		title.setBackground(new BaseColor(0, 0, 0), 
				(float) titlePadding,   // left 
				24f, 					// top
				(float) titlePadding,	// right 
				10f); // bottom

		// Place text chunk in paragraph in order to alter alignment
		Paragraph pTitle = new Paragraph();
		pTitle.add(title);
		pTitle.setAlignment(Element.ALIGN_CENTER);

		// Add title to document:
		document.add(pTitle);

		// Get current date and time and print as subtitle:
		DateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		Date date = new Date();
		Font subtitleFont = FontFactory.getFont(
				FontFactory.HELVETICA, 14, Font.NORMAL,
				new BaseColor(255,255,255));
		Paragraph subtitle = new Paragraph("Document generated: " + 
				dateFormat.format(date), subtitleFont);
		document.add(subtitle);

		/**********************************************************************
		 * Display project and tool information
		 *********************************************************************/
		document.add(new Paragraph("\nProject/dwelling name:",
				new Font(FontFamily.HELVETICA, 12, Font.BOLD)));
		LineSeparator lsTop = new LineSeparator(1, 100, null, Element.ALIGN_CENTER, 10);
		LineSeparator lsBtm = new LineSeparator();
		document.add(new Chunk(lsTop));

		String fileName = "Property ID " + Language.HouseID;
		Font fileFont = FontFactory.getFont(
				FontFactory.HELVETICA, 20, Font.BOLD);
		Chunk docName = new Chunk(fileName, fileFont);
		double filePadding = (lineWidth - docName.getWidthPoint());
		docName.setBackground(new BaseColor(238, 238, 238),
				0f, 
				38f,
				(float) filePadding, 
				11f);
		Paragraph pFile = new Paragraph();
		pFile.add(docName);
		document.add(pFile);
		document.add(new Chunk(lsBtm));
		String buildingType = Language.Construction;
		int buildingYear = 1950; //>> get from user input
		document.add(new Paragraph("Building type: " + buildingType + " (" + buildingYear + ")"));
		document.add(new Chunk(lsTop));
		Paragraph softwareNotes = new Paragraph("This document has been "
				+ "generated with a tool used for the purpose of evaluating "
				+ "the performance of retrofits to dwellings in "
				+ "order to ensure that it is meeting the expected energy "
				+ "performance benchmarks. "
				+ "Checks are also made to inspect the dwelling temperature "
				+ "and humidity post-upgrade.",
				new Font(FontFamily.TIMES_ROMAN, 12));
		softwareNotes.setAlignment(Element.ALIGN_JUSTIFIED);
		softwareNotes.setSpacingBefore(-6f);
		softwareNotes.setSpacingAfter(6f);
		document.add(softwareNotes);
		/**********************************************************************
		 * Display administrative information
		 *********************************************************************/
		String dwellingAddress = "**************";
		if(Language.ShowAddress.trim().equals("true")){
			dwellingAddress = Language.Address + "," + Language.PostCode; //"9 Fendoch Street, GLASGOW, G32 7TH";
		}
		String ownerName = "Glasgow City Council"; //Language.Client;
		String ownerContact = "+44(0)XXX-XXX-XXXX"; // Language.ClientContact;
		String ownerAddress = "City Chambers, GLASGOW, G2 1DU"; // Language.ClientAddress;
		String agentName = "John Allison"; // Language.Assessor;
		String agentContact = "+44(0)XXX-XXX-XXXX"; //Language.AssessorContact;
		String agentAddress = "James Weir Building, GLASGOW, G1 1XJ"; //Language.AssessorAddress;
				
		document.add(new Paragraph("Administrative information",
				new Font(FontFamily.HELVETICA, 12, Font.BOLD)));
		
		// A table with 2 columns:
		PdfPTable table = new PdfPTable(2);
		table.getDefaultCell().setBorder(0); // remove all borders
		
		// the cell object:
		PdfPCell cell;
		
		// now we add the contents
		cell = new PdfPCell(new Phrase("Building Details", new Font(FontFamily.HELVETICA, 12, Font.BOLD)));
		cell.setBorder(PdfPCell.NO_BORDER);
		table.addCell(cell);
		cell = new PdfPCell(new Phrase("Owner Details", new Font(FontFamily.HELVETICA, 12, Font.BOLD)));
		cell.setBorder(PdfPCell.NO_BORDER);
		table.addCell(cell);
		table.addCell("Address: " + dwellingAddress);
		table.addCell("Name: " + ownerName);
		table.addCell(" ");
		table.addCell("Contact #: " + ownerContact);
		cell = new PdfPCell(new Phrase("Certification Tool", new Font(FontFamily.HELVETICA, 12, Font.BOLD)));
		cell.setVerticalAlignment(Element.ALIGN_BOTTOM);
		cell.setBorder(PdfPCell.NO_BORDER);
		table.addCell(cell);
		table.addCell("Address: " + ownerAddress);
		table.addCell("Tool: POET");
		table.addCell(" ");
		table.addCell("Tool version: " + Language.version);
		cell = new PdfPCell(new Phrase("Agent Details", new Font(FontFamily.HELVETICA, 12, Font.BOLD)));
		cell.setBorder(PdfPCell.NO_BORDER);
		table.addCell(cell);
		table.addCell(" ");
		table.addCell("Name: " + agentName);
		table.addCell(" ");
		table.addCell("Contact #: " + agentContact);
		table.addCell(" ");
		table.addCell("Address: " + agentAddress);

		table.setSpacingBefore(12f);
		document.add(table);
		
		/**********************************************************************
		 * Display energy performance and benchmark
		 *********************************************************************/
		document.add(new Paragraph("1 - Energy Performance of Dwelling",
				new Font(FontFamily.HELVETICA, 12, Font.BOLD)));
		
		// A table with 4 columns:
		PdfPTable energyTable = new PdfPTable(4);

		// now we add the contents
		// headers:
		cell = new PdfPCell(new Phrase("Period", new Font(FontFamily.HELVETICA, 12, Font.BOLD)));
		energyTable.addCell(cell);
		cell = new PdfPCell(new Phrase("Gas (kWh)", new Font(FontFamily.HELVETICA, 12, Font.BOLD)));
		energyTable.addCell(cell);
		cell = new PdfPCell(new Phrase("Electricity (kWh)", new Font(FontFamily.HELVETICA, 12, Font.BOLD)));
		energyTable.addCell(cell);
		cell = new PdfPCell(new Phrase("Total (kWh)", new Font(FontFamily.HELVETICA, 12, Font.BOLD)));
		energyTable.addCell(cell);
		
/*		// table contents
 * Awaiting advice from John Allison about format of table
		energyTable.addCell("Pre-upgrade");
		energyTable.addCell(preUpgradeGas);
		energyTable.addCell(preUpgradeElec);
		energyTable.addCell(preUpgradeTotal);
		energyTable.addCell("Post-upgrade");
		energyTable.addCell(postUpgradeGas);
		energyTable.addCell(postUpgradeElec);
		energyTable.addCell(postUpgradeTotal);
*/		
		// format table and add to document
		energyTable.setSpacingBefore(12f);
		document.add(energyTable);
		
		// calculate retrofit rating
		double Rating = Language.DEP - Language.EPB;
		String grade;
		String textGrade;
		BaseColor gColor = new BaseColor(0,0,0);
		
		// need to add more categories...
		if (Rating > 0.005) {
			grade = "A+";
			textGrade = "Excellent";
			gColor = new BaseColor(1,103,1);
		} else if (Math.abs(Rating) <= 0.005) { // half % either side OK
			grade = "A";
			textGrade = "Great";
			gColor = new BaseColor(52,204,52);
		} else {
			grade = "F";
			textGrade = "Very Poor";
			gColor = new BaseColor(255,1,1);
		}
		grade = "B"; //Hardcoded just now but the above code should eventually go to EnergyAlgorithm.java
		textGrade = "Good";
		Font gradeFont = FontFactory.getFont(
				FontFactory.HELVETICA, 20, Font.NORMAL,
				new BaseColor(0,0,0));
		Chunk eGrade = new Chunk(grade, gradeFont);
		eGrade.setBackground(gColor, 6f, 6f, 6f, 6f);
		Chunk gText = new Chunk("      The energy performance of the dwelling post-upgrade is " + textGrade);
		
		Paragraph pGrade = new Paragraph();
		pGrade.add(eGrade);
		pGrade.add(gText);
		
		document.add(new Paragraph("Energy Performance Benchmark (%): " + Language.BenchMSaving));
		if(Language.savedEnergy.length() >= 5){
			document.add(new Paragraph("Actual saving achieved: " + Language.savedEnergy.substring(0, 4)));
		}else{
			document.add(new Paragraph("Actual saving achieved: Unknown"));
		}
		document.add(new Paragraph("Sample String"));
		document.add(new Paragraph(Language.res1 + Language.res2 + Language.res3 + Language.res4 + Language.res5 + 
				Language.res6 + Language.res7 + Language.res8 + Language.res9 + Language.res10));
		document.add(Chunk.NEWLINE);
		
		// for now display as text feedback:
		LineSeparator lsG = new LineSeparator(1, 101, gColor, Element.ALIGN_CENTER, 5);
		document.add(new Chunk(lsG));
		document.add(pGrade);
		document.add(new Chunk(lsG));

		/**********************************************************************
		 * Indoor environmental analysis
		 *********************************************************************/
		document.add(new Paragraph("2 - Indoor Environmental Analysis",
				new Font(FontFamily.HELVETICA, 12, Font.BOLD)));
		
		Image img1 = Image.getInstance(Pic1);
		img1.scaleToFit((float) lineWidth/3, 300);
		Image img2 = Image.getInstance(Pic2);
		img2.scaleToFit((float) lineWidth/3, 300);
		
		Paragraph figs = new Paragraph();
		figs.add(new Chunk(img2,0,-130));
		figs.add(new Chunk(img1,130,-130));
		document.add(figs);
		
		// step 5: Close the Document
		document.close();
	}

	public void createDocx(String dest){
		// Make replacements in the document.xml file and rename it as such
		// zip the folders in a file called docx
		// init InOut.docxReportFileNPath

		// Copy docx template
		InOut.docxReportFileNPath = InOut.currentFileNPath.replace(".poet", ".rtf");
//		System.out.println("Current file and path = " + InOut.currentFileNPath);
//		System.out.println("Current path = " + InOut.currentFileDir);
//		System.out.println("docx file and path = " + InOut.docxReportFileNPath);
		
		String fileMaster = InOut.currentFileDir + "template.rtf";
		String fileTemp = InOut.currentFileNPath.replace(".poet", ".tmp");
		String fileCopy = InOut.currentFileNPath.replace(".poet", ".rtf");
		File ft = new File(fileTemp);
		
		// Make replacements in the document
		FindReplaceString frs = new FindReplaceString();
		
		frs.replace(fileMaster, fileTemp, "Property ID:", "Property ID: " + Language.HouseID);
		frs.replace(fileTemp, fileCopy, "Project Area:", "Project Area: " + Language.WeatherFile.replace(".csv", ""));
		frs.replace(fileCopy, fileTemp, "Property Age band:" 	, "Property Age band: " + Language.PropertyAge);
		frs.replace(fileTemp, fileCopy, "Construction Type:" 	, "Construction Type: " + Language.Construction);
		frs.replace(fileCopy, fileTemp, "%Main upgrade type%"	, Language.UpgradeMeasures);
		frs.replace(fileTemp, fileCopy, "%PreUpStartDate%"		, Language.PreUpStartDate);
		frs.replace(fileCopy, fileTemp, "%PostUpEndDate%"		, Language.PostUpEndDate);
		frs.replace(fileTemp, fileCopy, "%to provide text%", "%to provide standard text here%");
		frs.replace(fileCopy, fileTemp, "%Rating from progress bar%"		, Language.Rating + "%");
		frs.replace(fileTemp, fileCopy, "%Upper alert from advanced tab%"	, Language.stptTemp1);
		frs.replace(fileCopy, fileTemp, "%high number of times for temp1%"	, Language.DebugT1MoreThanHigh);
		frs.replace(fileTemp, fileCopy, "%lower alert from advanced tab%"	, Language.stptTemp3);
		frs.replace(fileCopy, fileTemp, "%low number of times for temp1%"	, Language.DebugT1LessThanLow);
		frs.replace(fileTemp, fileCopy, "%HNTT2%"				, Language.DebugT2MoreThanHigh);
		frs.replace(fileCopy, fileTemp, "%LNTT2%"				, Language.DebugT2LessThanLow);
		frs.replace(fileTemp, fileCopy, "%kWh corresponding to postupend to preupstart%"	, Language.DebugEnergyUsedPostUpgradePeriod);
		Double ddd = Algorithm.DurationPostUpgradeMonPeriod;
		frs.replace(fileCopy, fileTemp, "%DCPP%", ddd.toString());
		frs.replace(fileTemp, fileCopy, "%lower alarm from advanced tab%",Language.stptTemp2);
		frs.replace(fileCopy, fileTemp, "%Upper alarm from advanced tab%",Language.stptTemp4);
		frs.replace(fileTemp, fileCopy, "%higher number of times for temp1%",Language.DebugT1MoreThanHigher);
		frs.replace(fileCopy, fileTemp, "%lower number of times for temp1%",Language.DebugT1LessThanLower);
		frs.replace(fileTemp, fileCopy, "%HerNTT2%",Language.DebugT2MoreThanHigher);
		frs.replace(fileCopy, fileTemp, "%LerNTT2%",Language.DebugT2LessThanLower);
		
		if(Language.SurveyConducted.equals("yes")){
			frs.replace(fileTemp, fileCopy, "%Survey information to follow%","Survey Results");
			frs.replace(fileCopy, fileTemp, "%Survey QA1%","1. " + Language.surveyQs1 + " " + Language.SurveyAns1);
			frs.replace(fileTemp, fileCopy, "%Survey QA2%","2. " + Language.surveyQs2 + " " + Language.SurveyAns2);
			frs.replace(fileCopy, fileTemp, "%Survey QA3%","3. " + Language.surveyQs3 + " " + Language.SurveyAns3);
			frs.replace(fileTemp, fileCopy, "%Survey QA4%","4. " + Language.surveyQs4 + " " + Language.SurveyAns4);
			frs.replace(fileCopy, fileTemp, "%Survey QA5%","5. " + Language.surveyQs5 + " " + Language.SurveyAns5);
			frs.replace(fileTemp, fileCopy, "%Survey QA6%","6. " + Language.surveyQs6 + " " + Language.SurveyAns6);
		}else{
			frs.replace(fileTemp, fileCopy, "%Survey information to follow%","Survey not conducted for this site");
			frs.replace(fileCopy, fileTemp, "%Survey QA1%","");
			frs.replace(fileTemp, fileCopy, "%Survey QA2%","");
			frs.replace(fileCopy, fileTemp, "%Survey QA3%","");
			frs.replace(fileTemp, fileCopy, "%Survey QA4%","");
			frs.replace(fileCopy, fileTemp, "%Survey QA5%","");
			frs.replace(fileTemp, fileCopy, "%Survey QA6%","");
		}
		
//		frs.replace(fileCopy, fileTemp, "","");
//		frs.replace(fileTemp, fileCopy, "","");
		ft.delete();
	}
	
	/* %Survey information to follow%
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 */
	
	
	
	static void CopyFile(File a, File b){
		try {
			//FileUtils.copyDirectory(srcDir, destDir);
			FileUtils.copyFile(a, b);
			//System.out.println("Copy " + srcDirStr + " to " + destDirStr);
		} catch (IOException e) {
			e.printStackTrace();
		}

	}
}














