# Installer for POET 
!include "MUI.nsh"

Name POET

# General Symbol Definitions
!define REGKEY "SOFTWARE\$(^Name)"
!define VERSION 3.62
!define COMPANY "ESRU, University of Strathclyde"
!define URL "strath.ac.uk/esru"

# Variables
Var StartMenuGroup

!define MUI_ICON G:\Verbatim500GB\SharedDataPartition\Eclipse\Workbench\ESRU.ico
!define MUI_UNICON G:\Verbatim500GB\SharedDataPartition\Eclipse\Workbench\ESRU.ico
!define MUI_PAGE_CUSTOMFUNCTION_PRE WelcomePageSetupLinkPre
!define MUI_PAGE_CUSTOMFUNCTION_SHOW WelcomePageSetupLinkShow

!define MUI_STARTMENUPAGE_REGISTRY_ROOT HKLM
!define MUI_STARTMENUPAGE_NODISABLE
!define MUI_STARTMENUPAGE_REGISTRY_KEY ${REGKEY}
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME StartMenuGroup
!define MUI_STARTMENUPAGE_DEFAULTFOLDER POET
!define MUI_UNFINISHPAGE_NOAUTOCLOSE




!insertmacro MUI_PAGE_WELCOME
# Ask which components to install
#!insertmacro MUI_PAGE_COMPONENTS
!insertmacro MUI_PAGE_LICENSE "License.txt"

# Ask where to install 
!insertmacro MUI_PAGE_DIRECTORY

!insertmacro MUI_PAGE_STARTMENU Application $StartMenuGroup
!insertmacro MUI_PAGE_INSTFILES


# Installer attributes
OutFile POET_Setup.exe
InstallDir $PROFILE\POET
CRCCheck on
XPStyle on
ShowInstDetails show
VIProductVersion 0.1.0.0
VIAddVersionKey ProductName POET
VIAddVersionKey ProductVersion "${VERSION}"
VIAddVersionKey CompanyName "${COMPANY}"
VIAddVersionKey CompanyWebsite "${URL}"
VIAddVersionKey FileVersion "${VERSION}"
VIAddVersionKey FileDescription ""
VIAddVersionKey LegalCopyright ""
#InstallDirRegKey HKLM "${REGKEY}" Path
ShowUninstDetails show

 
Section "secDummy"
  ; ...
SectionEnd
 
 
Function WelcomePageSetupLinkPre
  !insertmacro MUI_INSTALLOPTIONS_WRITE "ioSpecial.ini" "Settings" "Numfields" "4" ; increase counter
  !insertmacro MUI_INSTALLOPTIONS_WRITE "ioSpecial.ini" "Field 3" "Bottom" "122" ; limit size of the upper label
  !insertmacro MUI_INSTALLOPTIONS_WRITE "ioSpecial.ini" "Field 4" "Type" "Link"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "ioSpecial.ini" "Field 4" "Text" "http://www.strath.ac.uk/esru/"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "ioSpecial.ini" "Field 4" "State" "http://www.strath.ac.uk/esru/"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "ioSpecial.ini" "Field 4" "Left" "120"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "ioSpecial.ini" "Field 4" "Right" "315"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "ioSpecial.ini" "Field 4" "Top" "123"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "ioSpecial.ini" "Field 4" "Bottom" "132"
FunctionEnd
 
Function WelcomePageSetupLinkShow
  ; Thanks to pengyou
  ; Fix colors of added link control
  ; See http://forums.winamp.com/showthread.php?s=&threadid=205674
  Push $0
 
  GetDlgItem $0 $MUI_HWND 1203
  SetCtlColors $0 "0000FF" "FFFFFF"
  ; underline font
  CreateFont $1 "$(^Font)" "$(^FontSize)" "400" /UNDERLINE 
  SendMessage $0 ${WM_SETFONT} $1 1 
  Pop $0
 FunctionEnd
 
;--------------------------------
;Languages
 
  !insertmacro MUI_LANGUAGE "English"
  
  
  
  




# Name the installer
OutFile "POET_Setup.exe"

# Set the install directory (done above)
# InstallDir $PROFILE\POET
RequestExecutionLevel user

Section
    # Set output path
    SetOutPath $INSTDIR
    
    # Specify file to go in output path
    # /r for recursively copying folder
    # go from POET/src/uk/ac/strath/esru/ to POET/
    File  /r ..\..\..\..\..\POET\*
    
    # Define uninstaller name
    WriteUninstaller $INSTDIR\uninstaller.exe 
SectionEnd

Section "Desktop Shortcut" SHORTCUT


     SetOutPath "$INSTDIR"
     CreateShortcut "$DESKTOP\POET.lnk" "$INSTDIR\bin\POET.jar" "" "$INSTDIR\ESRU.ico" 0

    # Start Menu
    createDirectory "$SMPROGRAMS\${COMPANY}"
    createShortCut "$SMPROGRAMS\${COMPANY}\POET.lnk" "$INSTDIR\POET.jar" "" "$INSTDIR\ESRU.ico" 0
    createShortCut "$SMPROGRAMS\${COMPANY}\Uninstall.lnk" "$INSTDIR\uninstaller.exe"
SectionEnd



Section "Uninstall"
    # Remove Start Menu launcher
    delete "$SMPROGRAMS\${COMPANY}\Uninstall.lnk"
    delete "$SMPROGRAMS\${COMPANY}\POET.lnk"
    
    # Try to remove the Start Menu folder - this will only happen if it is empty
    rmDir "$SMPROGRAMS\${COMPANY}"
    
    # Remove desktop launcher
    delete "$DESKTOP\POET.lnk"

    # Always delete uninstaller first
    Delete $INSTDIR\uninstaller.exe
     
    # now delete installed file
    RMDir /r $INSTDIR
SectionEnd