package uk.ac.strath.esru;

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import javax.swing.SwingConstants;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JTextArea;
import javax.swing.UIManager;
import java.awt.Font;
import net.miginfocom.swing.MigLayout;
//import javax.swing.*;

public class UserDialog extends JDialog {

	private final JPanel contentPanel = new JPanel();
	Language l = new Language();
	int option = 0;

	/* constructors are called following the syntax (text for button1, text for button2, 
	 * ..., int dummy, text for user message heading, text for user message) 
	 * 
	 */

	public UserDialog(String button1, int dummy, String userMsgHead, String userMessage) {
		setBounds(FrameDef.xx, FrameDef.yy, 400, 300);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setFont(new Font("Tahoma", Font.BOLD, 12));
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(new MigLayout("", "[20px,grow]", "[14px][18px,grow,center]"));
		{
			JLabel lblLabel = new JLabel(userMsgHead);
			lblLabel.setFont(new Font("Tahoma", Font.BOLD, 11));
			lblLabel.setHorizontalTextPosition(SwingConstants.CENTER);
			lblLabel.setHorizontalAlignment(SwingConstants.CENTER);
			contentPanel.add(lblLabel, "cell 0 0, grow");
		}
		{
			JTextArea txtrTextHere = new JTextArea();
			txtrTextHere.setEditable(false);
			txtrTextHere.setWrapStyleWord(true);
			txtrTextHere.setLineWrap(true);
			txtrTextHere.setFont(new Font("Tahoma", Font.PLAIN, 11));
			txtrTextHere.setBackground(UIManager.getColor("CheckBox.background"));
			txtrTextHere.setText(userMessage);
			contentPanel.add(txtrTextHere, "cell 0 0,grow");
		}
		{
			JPanel buttonPane = new JPanel();
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			buttonPane.setLayout(new FlowLayout(FlowLayout.CENTER, 5, 5));
			{
				JButton jButton1 = new JButton(button1);
				jButton1.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {
						option = 1;
						dispose();
					}
				});
				buttonPane.add(jButton1);
				getRootPane().setDefaultButton(jButton1);
			}
			dummy = option;
		}
		setModalityType(ModalityType.APPLICATION_MODAL); // Focus will not return to parent window
	}
	
	// 2 button dialog box
	public UserDialog(String button1, String button2, int dummy, String userMsgHead, String userMessage) {
		setBounds(FrameDef.xx, FrameDef.yy, 400, 300);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setFont(new Font("Tahoma", Font.BOLD, 12));
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(new MigLayout("", "[20px,grow]", "[14px][18px,grow,center]"));
		{
			JLabel lblLabel = new JLabel(userMsgHead);
			lblLabel.setFont(new Font("Tahoma", Font.BOLD, 11));
			lblLabel.setHorizontalTextPosition(SwingConstants.CENTER);
			lblLabel.setHorizontalAlignment(SwingConstants.CENTER);
			contentPanel.add(lblLabel, "cell 0 0, grow");
		}
		{
			JTextArea txtrTextHere = new JTextArea();
			txtrTextHere.setEditable(false);
			txtrTextHere.setWrapStyleWord(true);
			txtrTextHere.setLineWrap(true);
			txtrTextHere.setFont(new Font("Tahoma", Font.PLAIN, 11));
			txtrTextHere.setBackground(UIManager.getColor("CheckBox.background"));
			txtrTextHere.setText(userMessage);
			contentPanel.add(txtrTextHere, "cell 0 0,grow");
		}
		{
			JPanel buttonPane = new JPanel();
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			buttonPane.setLayout(new FlowLayout(FlowLayout.CENTER, 5, 5));
			{
				JButton jButton1 = new JButton(button1);
				jButton1.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {
						option = 1;
						dispose();
					}
				});
				buttonPane.add(jButton1);
				getRootPane().setDefaultButton(jButton1);
			}
			{
				JButton jButton2 = new JButton(button2);
				jButton2.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						option = 2;
						dispose();
					}
				});
				buttonPane.add(jButton2);
			}
			dummy = option;
		}
		setModalityType(ModalityType.APPLICATION_MODAL); // Focus will not return to parent window
	}
	
	// 3 button dialog box
	public UserDialog(String button1, String button2, String button3, int dummy, String userMsgHead, String userMessage) {
		setBounds(FrameDef.xx, FrameDef.yy, 400, 300);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setFont(new Font("Tahoma", Font.BOLD, 12));
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(new MigLayout("", "[20px,grow]", "[14px][18px,grow,center]"));
		{
			JLabel lblLabel = new JLabel(userMsgHead);
			lblLabel.setFont(new Font("Tahoma", Font.BOLD, 11));
			lblLabel.setHorizontalTextPosition(SwingConstants.CENTER);
			lblLabel.setHorizontalAlignment(SwingConstants.CENTER);
			contentPanel.add(lblLabel, "cell 0 0, grow");
		}
		{
			JTextArea txtrTextHere = new JTextArea();
			txtrTextHere.setEditable(false);
			txtrTextHere.setWrapStyleWord(true);
			txtrTextHere.setLineWrap(true);
			txtrTextHere.setFont(new Font("Tahoma", Font.PLAIN, 11));
			txtrTextHere.setBackground(UIManager.getColor("CheckBox.background"));
			txtrTextHere.setText(userMessage);
			contentPanel.add(txtrTextHere, "cell 0 0,grow");
		}
		{
			JPanel buttonPane = new JPanel();
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			buttonPane.setLayout(new FlowLayout(FlowLayout.CENTER, 5, 5));
			{
				JButton jButton1 = new JButton(button1);
				jButton1.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {
						option = 1;
						dispose();
					}
				});
				buttonPane.add(jButton1);
				getRootPane().setDefaultButton(jButton1);
			}
			{
				JButton jButton2 = new JButton(button2);
				jButton2.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						option = 2;
						dispose();
					}
				});
				buttonPane.add(jButton2);
			}
			{
				JButton jButton3 = new JButton(button3);
				jButton3.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						option = 3;
						dispose();
					}
				});
				buttonPane.add(jButton3);
			}
			dummy = option;
		}
		setModalityType(ModalityType.APPLICATION_MODAL); // Focus will not return to parent window
	}
	
	public int optionChosen(){
		return option;
	}

}
